!c Description:
!c   ʿվ狼¸ߤǤʤؼ򥫥å
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-03-01    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_chk_equiv
  interface
     
     subroutine chk_equiv(mu0, phase, name, ssw, sw)
       real(8), intent(in)               :: mu0(:)
       integer, intent(in)               :: phase(:)
       logical, intent(out), allocatable :: ssw(:) 
       logical, intent(out)              :: sw
       character(*), intent(in)          :: name(:)
     end subroutine chk_equiv
     
  end interface
end module interface_chk_equiv




subroutine chk_equiv(mu0, phase, name, ssw, sw)
  use interface_name_cnd2gas
  use interface_name2num
  
  implicit none
  real(8), intent(in)               :: mu0(:)
  integer, intent(in)               :: phase(:)
  logical, intent(out), allocatable :: ssw(:) 
  logical, intent(out)              :: sw
  character(*), intent(in)          :: name(:)
  
  integer, allocatable              :: num(:)    
  integer                           :: N
  integer                           :: s, t
  character(80)                     :: gasname
  

!!!
!!!
!!!
  N = size(name, 1)
  if (allocated(ssw)) deallocate(ssw)
  allocate(ssw(N), num(N))
  ssw = .true.; sw = .false.  
  num = 0 

  
!!!
!!!, б뵤ֹ
!!!  
  do s = 1, N
     if (phase(s) == 1) cycle
     call name_cnd2gas(name(s), gasname)
     call name2num(gasname, name, num(s))
  end do
  
  
!!!
!!!ȸ꤬¸ߤȽ
!!!
  cut: do s = 1, N - 1
     if (phase(s) /= 4) cycle cut
     
     do t = s + 1, N
        if(num(s) == num(t)) then 
           if (mu0(s) > mu0(t)) then  
              ssw(s) = .false. 
              sw = .true.
           else
              ssw(t) = .false. 
              sw = .true. 
           end if
        end if        
     end do
  end do cut


!!!
!!!夫Ť
!!!
  deallocate(num)

end subroutine chk_equiv
